
#include "comb/permlex.h"

#include "comb/fact2perm.h"

#include "comb/printmixedradix.h"

#include "fxttypes.h"
#include "fxtio.h"
#include "demo/nextarg.h"


//% Generate all permutations in lexicographic order.

//#define TIMING // uncomment to disable printing

int
main(int argc, char **argv)
{
    ulong n = 4;
    NXARG(n, "Permutations of n elements.");
    bool dfz= true; // whether to print dots for zeros

    perm_lex P(n);
#ifdef TIMING
    while ( P.next() )  {;}
#else
    const ulong *x = P.data();
    ulong *fc = new ulong[n-1];
    ulong ct = 0;
    do
    {
        cout << setw(4) << ct << ":";
        ++ct;

        P.print("    ", dfz);

        perm2ffact(x, n, fc);
        print_mixedradix("    ", fc, n-1, dfz);

        cout << endl;
    }
    while ( P.next() );
#endif

    return 0;
}
// -------------------------

/*
Timing:
time ./bin 12
arg 1: 12 == n  [Permutations of n elements.]  default=4
./bin 12  4.76s user 0.02s system 100% cpu 4.785 total
 12!/4.785 == 100,104,827 permutations per second
*/
