
#include "comb/subset-lex.h"

#include "comb/printset.h"
#include "fxttypes.h"

#include "fxtio.h"
#include "fxtiomanip.h"
#include "demo/nextarg.h"


//% Generate all subsets in lexicographic order.

//#define TIMING // uncomment to disable printing

int
main(int argc, char **argv)
{
    ulong n = 5;
    NXARG(n, "Size of the set");
    subset_lex S(n);

#ifdef TIMING
    while ( S.next() )  {;}

#else // TIMING
    ulong idx = 0;
    ulong num = S.first();
    const ulong *x = S.data();
    do
    {
        cout << setw(2) << idx;
        ++idx;

        cout << "  #=" << setw(2) << num << ":  ";
        print_set_as_deltaset("  ", x, num, n);
        print_set("  ", x, num);
        cout << endl;
    }
    while ( (num = S.next()) );

    cout << endl;
    num = S.last();
    do
    {
        cout << setw(2) << idx;
        ++idx;

        cout << "  #=" << setw(2) << num << ":  ";
        print_set_as_deltaset("  ", x, num, n);
        print_set("  ", x, num);
        cout << endl;
    }
    while ( (num = S.prev()) );
#endif // TIMING

    return 0;
}
// -------------------------

/*
Timing:
% time ./bin 30
arg 1: 30 == n  [Size of the set]  default=5
./bin 30  4.56s user 0.02s system 99% cpu 4.582 total
 ==> 2^30/4.582 == 234,339,114 subsets per second
*/
