

#include "fxttypes.h"
#include "bpol/bitpolmodarith.h"
#include "mod/factor.h"

//#include "bpol/gf2nfuncs.h"



ulong
gf2n_order(ulong x, ulong c, ulong hc, const factorization &mfact)
// Return order of x \in GF(2**n).
// The polynomial c must be irreducible,
//  else the routine loops forever.
{
    if ( 0==x )  return 0;

    ulong h = mfact.product();
    ulong e = h;
    for (int i=0; i<mfact.nprimes() ; ++i)
    {
        long p = mfact.prime(i);
        long f = mfact.primepow(i);

        e /= f;
        ulong g1 = bitpolmod_power(x, e, c, hc);
        while ( g1!=1 )
        {
            g1 = bitpolmod_power(g1, p, c, hc);
            e *= p;
        }
    }

    return e;
}
// -------------------------
