
#include "fxttypes.h"

ulong
mixedradix2num(const ulong *x, const ulong *m1, ulong n, bool rq/*=false*/)
// Convert n-digit mixed radix number in x[] to (unsigned) integer.
// Radices (minus one, i.e. nines) must be given in m1[].
// If rq is true, compute value of reversed mixed radix number.
{
    ulong r = 0;
    ulong p = 1;  // multiplier

    if ( rq )
    {
        for (ulong k=n-1; (long)k>=0; --k)  // reverse digits
        {
            ulong t = x[k];
//            if ( t )  t = m1[k]+1-t;  // complement non-zero digits
            r += p*t;
            p *= m1[k]+1;
        }
    }
    else
    {
        for (ulong k=0; k<n; ++k)
        {
            ulong t = x[k];
//            if ( t )  t = m1[k]+1-t;  // complement non-zero digits
            r += p*t;
            p *= m1[k]+1;
        }
    }

    return r;
}
// -------------------------
